package botserviceapi

// Copyright (c) Microsoft and contributors.  All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"context"
	"github.com/Azure/azure-sdk-for-go/services/preview/botservice/mgmt/2018-07-12/botservice"
	"github.com/Azure/go-autorest/autorest"
)

// BotsClientAPI contains the set of methods on the BotsClient type.
type BotsClientAPI interface {
	Create(ctx context.Context, resourceGroupName string, resourceName string, parameters botservice.Bot) (result botservice.Bot, err error)
	Delete(ctx context.Context, resourceGroupName string, resourceName string) (result autorest.Response, err error)
	Get(ctx context.Context, resourceGroupName string, resourceName string) (result botservice.Bot, err error)
	GetCheckNameAvailability(ctx context.Context, parameters botservice.CheckNameAvailabilityRequestBody) (result botservice.CheckNameAvailabilityResponseBody, err error)
	List(ctx context.Context) (result botservice.BotResponseListPage, err error)
	ListByResourceGroup(ctx context.Context, resourceGroupName string) (result botservice.BotResponseListPage, err error)
	Update(ctx context.Context, resourceGroupName string, resourceName string, parameters botservice.Bot) (result botservice.Bot, err error)
}

var _ BotsClientAPI = (*botservice.BotsClient)(nil)

// ChannelsClientAPI contains the set of methods on the ChannelsClient type.
type ChannelsClientAPI interface {
	Create(ctx context.Context, resourceGroupName string, resourceName string, channelName botservice.ChannelName, parameters botservice.BotChannel) (result botservice.BotChannel, err error)
	Delete(ctx context.Context, resourceGroupName string, resourceName string, channelName string) (result autorest.Response, err error)
	Get(ctx context.Context, resourceGroupName string, resourceName string, channelName string) (result botservice.BotChannel, err error)
	ListByResourceGroup(ctx context.Context, resourceGroupName string, resourceName string) (result botservice.ChannelResponseListPage, err error)
	ListWithKeys(ctx context.Context, resourceGroupName string, resourceName string, channelName botservice.ChannelName) (result botservice.BotChannel, err error)
	Update(ctx context.Context, resourceGroupName string, resourceName string, channelName botservice.ChannelName, parameters botservice.BotChannel) (result botservice.BotChannel, err error)
}

var _ ChannelsClientAPI = (*botservice.ChannelsClient)(nil)

// OperationsClientAPI contains the set of methods on the OperationsClient type.
type OperationsClientAPI interface {
	List(ctx context.Context) (result botservice.OperationEntityListResultPage, err error)
}

var _ OperationsClientAPI = (*botservice.OperationsClient)(nil)

// BotConnectionClientAPI contains the set of methods on the BotConnectionClient type.
type BotConnectionClientAPI interface {
	Create(ctx context.Context, resourceGroupName string, resourceName string, connectionName string, parameters botservice.ConnectionSetting) (result botservice.ConnectionSetting, err error)
	Delete(ctx context.Context, resourceGroupName string, resourceName string, connectionName string) (result autorest.Response, err error)
	Get(ctx context.Context, resourceGroupName string, resourceName string, connectionName string) (result botservice.ConnectionSetting, err error)
	ListByBotService(ctx context.Context, resourceGroupName string, resourceName string) (result botservice.ConnectionSettingResponseListPage, err error)
	ListServiceProviders(ctx context.Context) (result botservice.ServiceProviderResponseList, err error)
	ListWithSecrets(ctx context.Context, resourceGroupName string, resourceName string, connectionName string) (result botservice.ConnectionSetting, err error)
	Update(ctx context.Context, resourceGroupName string, resourceName string, connectionName string, parameters botservice.ConnectionSetting) (result botservice.ConnectionSetting, err error)
}

var _ BotConnectionClientAPI = (*botservice.BotConnectionClient)(nil)

// EnterpriseChannelsClientAPI contains the set of methods on the EnterpriseChannelsClient type.
type EnterpriseChannelsClientAPI interface {
	CheckNameAvailability(ctx context.Context, parameters botservice.EnterpriseChannelCheckNameAvailabilityRequest) (result botservice.EnterpriseChannelCheckNameAvailabilityResponse, err error)
	Create(ctx context.Context, resourceGroupName string, resourceName string, parameters botservice.EnterpriseChannel) (result botservice.EnterpriseChannelsCreateFuture, err error)
	Delete(ctx context.Context, resourceGroupName string, resourceName string) (result botservice.EnterpriseChannelsDeleteFuture, err error)
	Get(ctx context.Context, resourceGroupName string, resourceName string) (result botservice.EnterpriseChannel, err error)
	ListByResourceGroup(ctx context.Context, resourceGroupName string) (result botservice.EnterpriseChannelResponseListPage, err error)
	Update(ctx context.Context, resourceGroupName string, resourceName string, parameters botservice.EnterpriseChannel) (result botservice.EnterpriseChannelsUpdateFuture, err error)
}

var _ EnterpriseChannelsClientAPI = (*botservice.EnterpriseChannelsClient)(nil)
