package customprovidersapi

// Copyright (c) Microsoft and contributors.  All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"context"
	"github.com/Azure/azure-sdk-for-go/services/preview/customproviders/mgmt/2018-09-01-preview/customproviders"
)

// OperationsClientAPI contains the set of methods on the OperationsClient type.
type OperationsClientAPI interface {
	List(ctx context.Context) (result customproviders.ResourceProviderOperationListPage, err error)
}

var _ OperationsClientAPI = (*customproviders.OperationsClient)(nil)

// CustomResourceProviderClientAPI contains the set of methods on the CustomResourceProviderClient type.
type CustomResourceProviderClientAPI interface {
	CreateOrUpdate(ctx context.Context, resourceGroupName string, resourceProviderName string, resourceProvider customproviders.CustomRPManifest) (result customproviders.CustomResourceProviderCreateOrUpdateFuture, err error)
	Delete(ctx context.Context, resourceGroupName string, resourceProviderName string) (result customproviders.CustomResourceProviderDeleteFuture, err error)
	Get(ctx context.Context, resourceGroupName string, resourceProviderName string) (result customproviders.CustomRPManifest, err error)
	ListByResourceGroup(ctx context.Context, resourceGroupName string) (result customproviders.ListByCustomRPManifestPage, err error)
	ListBySubscription(ctx context.Context) (result customproviders.ListByCustomRPManifestPage, err error)
	Update(ctx context.Context, resourceGroupName string, resourceProviderName string, patchableResource customproviders.ResourceProvidersUpdate) (result customproviders.CustomRPManifest, err error)
}

var _ CustomResourceProviderClientAPI = (*customproviders.CustomResourceProviderClient)(nil)

// AssociationsClientAPI contains the set of methods on the AssociationsClient type.
type AssociationsClientAPI interface {
	CreateOrUpdate(ctx context.Context, scope string, associationName string, association customproviders.Association) (result customproviders.AssociationsCreateOrUpdateFuture, err error)
	Delete(ctx context.Context, scope string, associationName string) (result customproviders.AssociationsDeleteFuture, err error)
	Get(ctx context.Context, scope string, associationName string) (result customproviders.Association, err error)
	ListAll(ctx context.Context, scope string) (result customproviders.AssociationsListPage, err error)
}

var _ AssociationsClientAPI = (*customproviders.AssociationsClient)(nil)
